#include <stdio.h>
#include "mainhdr.h"


void expression();     /*---- Prototypes ----*/


void next(){  /*--------  Finds next character   ---- */

  char_in_hand=char_ahead;
  char_ahead= (char) getchar();
}

void checkfor(char symbol){     /*---- Checks char for symbol -----*/

 if ( char_in_hand != symbol)
   {printf("Expected : %c  but found '%c'\n",symbol,char_in_hand);
    exit(1);
   }
}

void addsign(){    /*------- Adds a node containing sign, not digit -----*/
 struct node *temp;

 temp = (struct node *) malloc(sizeof(struct node));
 temp->lexeme = char_in_hand;
 temp->parent = root->parent;
 root->parent->right = temp;
 temp->left = root;
 root->parent = temp;
 root = temp;
}
 

void factor(){     /*----- Checks for factor ----*/
  struct node *temp;
           
  if(char_in_hand == T_LBRA){
     next();
     expression();
     next();
     checkfor(T_RBRA);
     root = root->parent;   /*--- Parent of root becomes root ---*/
     }
  else{ 
       if(islower(char_in_hand)||isdigit(char_in_hand))   /*--- Add node --*/
	  {
	   root->right = (struct node *) malloc(sizeof(struct node));
	   root->right->parent = root;
	   root->right->lexeme = char_in_hand;
	   root = root->right;               /*--New node becomes root--*/
          }
       else{ 
            printf("Invalid Input:  %c\n",char_in_hand);
	     exit(1);
       }
  }
 return;
}

void term(){    /*---- Checks for term ----*/

 factor();
 if((char_ahead==T_STAR)||(char_ahead==T_SLASH))   /*--- Look-ahead ---*/
   {
    next();
    addsign();
    next();
    factor();
   }
 return;
}

void expression(){    /*--- Checks for expression ---*/

 term();
 if((char_ahead==T_PLUS)||(char_ahead==T_MINUS))   /*--- Look-ahead ---*/
    {next();
     addsign();
     next();
     term();
    }
 return;
}

void goal(){

 expression();
 next();
 checkfor(T_SEMICOLON);
 return;
}


void print_tree(struct node *p, int level){  
                                //--- Prints tree in NLR mode ---
 int i;

 for(i=0; i<level; i++)
       printf(" ");
 printf("%c\n",p->lexeme);
 if(p->left != NULL)
   print_tree(p->left,level+1);
 if(p->right != NULL)
   print_tree(p->right,level+1);
}



void init(){
 int r,c;

 root = (struct node *) malloc(sizeof(struct node)); 
 root->parent = NULL;
 char_in_hand = (char) getchar();
 char_ahead = (char) getchar();
} 

int main()
{ //struct node *temp;
 
 init();
// temp=root;
 printf("Done init\n");
 goal();
 printf("Done goal\n");


 while(root->parent!=NULL)   // Find actual roo
   { printf("Attempting... %d\n",root->parent);
     root=root->parent;
   }

// root = temp;

 printf("Found root\n");
 root=root->right;          /*--- Actual tree starts here ---*/
 printf("Found start\n");
 print_tree(root,0);
}





